#include <e32std.h>
#include <apmrec.h>
#include <apmstd.h>
#include <f32file.h>
#include "ChessRec.h"

const TInt KMimeChessRecognizerValue = 0x10009BBA;
const TUid KUidChessRecognizer={KMimeChessRecognizerValue};

_LIT8(KChessDataType, "application/echess");

CApaChessRecognizer::CApaChessRecognizer()
	: CApaDataRecognizerType(KUidChessRecognizer, CApaDataRecognizerType::ENormal)
{
	iConfidence = ENotRecognized;
	iCountDataTypes = 1;
}

TUint CApaChessRecognizer::PreferredBufSize()
{
	return 0;
}

TDataType CApaChessRecognizer::SupportedDataTypeL(TInt aIndex) const
{
	return (aIndex == 0) ? TDataType(KChessDataType) : TDataType();
}

void CApaChessRecognizer::DoRecognizeL(const TDesC& aName, const TDesC8& /*aBuffer*/)
{
	_LIT(KPgnChessFile, ".pgn");
	_LIT(KGamChessFile, ".gam");

	iDataType = TDataType(KChessDataType);
	TParsePtrC fileName(aName);
	if (fileName.Ext().CompareF(KPgnChessFile) == 0)
		iConfidence = ECertain;
	else if (fileName.Ext().CompareF(KGamChessFile) == 0)
		iConfidence = ECertain;
	else
		iConfidence = ENotRecognized;
}


EXPORT_C CApaDataRecognizerType* CreateRecognizer()
{
	CApaDataRecognizerType* apaChessRecognizer =new CApaChessRecognizer;
	return apaChessRecognizer;
}


TInt E32Dll(TDllReason /*aReason*/)
{
	return KErrNone;
}
