/*******************************************************************
 *
 *	File:		EGnuChessModelObserver.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2002, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __E_GNU_CHESS_MODEL_OBSERVER_H
#define __E_GNU_CHESS_MODEL_OBSERVER_H

class MEGnuChessModelBoardObserver
{
public:
	virtual void RedrawL(TBool aFullRedraw) = 0;
	virtual void DrawHighlightsL() = 0;
};

class MEGnuChessModelGameObserver
{
public:
	virtual void UserThinksL() = 0;
	virtual void MachineThinksL() = 0;
	virtual void DisplayMessageL(const TDesC& aMessage) = 0;
	virtual void CommentPopUpL(const TDesC& aTitle, const TDesC& aComment) = 0;
	virtual void CommentPopDown() = 0;
	virtual void EditCommentPopUpL(TInt aIndex, const TDesC& aTitle, const TDesC& aComment) = 0;
	virtual void ModeHighlightL() = 0;
};

class MEGnuChessModelTimeObserver
{
public:
	virtual void UpdateTimeClockL(TBool aWhite, const TDesC& aTimeString, TBool aHighlight) = 0;
};

#endif			/* __E_GNU_CHESS_MODEL_OBSERVER_H */

