/*******************************************************************
 *
 *	File:		EGnuChessApplication.cpp
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2002, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#include "EGnuChessApplication.h"
#include "EGnuChessDocument.h"
#include "EGnuChessUids.h"
#include "debug.h"

CApaDocument* CEGnuChessApplication::CreateDocumentL()
{
	return CEGnuChessDocument::NewL(*this);
}


TFileName CEGnuChessApplication::AppFullName()const
{
	TFileName	name;
#ifdef __WINS__
	name = _L("z:\\system\\programs\\echess.exe");
	return name;
#else
	RProcess	me;
	name = me.FileName();
#endif
	DPRINT((_L("CEGnuChessApplication::AppFullName: %S"), &name));
	return name;
}


TUid CEGnuChessApplication::AppDllUid() const
{
	return(KUidEGnuChessApp);
}


CApaApplication* NewApplication()
{
	return new CEGnuChessApplication();
}


