/*******************************************************************
 *
 *	File:		EGnuChessDocument.cpp
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2002, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#include "EGnuChessDocument.h"
#include "EGnuChessAppUi.h"
#include "EGnuChessApplication.h"
#include <EChess.rsg>
#include "debug.h"

CEGnuChessDocument::CEGnuChessDocument(CEikApplication& aApp) : CQikDocument(aApp)
{
}

CEGnuChessDocument::~CEGnuChessDocument()
{
	delete iModel;
}


CEGnuChessDocument* CEGnuChessDocument::NewL(CEikApplication& aApp)
{
	CEGnuChessDocument* self = new (ELeave) CEGnuChessDocument(aApp);
	CleanupStack::PushL(self);
	self->ConstructL();
	CleanupStack::Pop(self); 
	return self;
}

void CEGnuChessDocument::ConstructL()
{
	iModel = CEGnuChessModel::NewL(*this);
}

CEikAppUi* CEGnuChessDocument::CreateAppUiL()
{
	return new(ELeave) CEGnuChessAppUi();
}


