/*******************************************************************
 *
 *	File:		EikonExe.cpp
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2002, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#include <e32std.h>
#include <eikapp.h>
#include <eikenv.h>
#include <eikdll.h>
#include "EGnuChessUids.h"
#include "debug.h"

RChunk	sGlobalDataChunk;

CApaApplication* NewApplication();

void CreateApplicationL()
{
	DPRINT((HERE("CreateApplicationL - 1")));

		/*
		 * Create the Application object and store its pointer
		 * in a named global chunk.
		 * When out .app starts up it will retrieve that pointer
		 * and return it in its NewApplication();
		 */
	CApaApplication*	app = NewApplication();
	CApaApplication**	appPtr;
	
	User::LeaveIfNull(app);
	DPRINT((HERE("CreateApplicationL - 2")));
	User::LeaveIfError(sGlobalDataChunk.CreateGlobal(KGlobalEChessChunkName, 4, 4));
	DPRINT((HERE("CreateApplicationL - 3")));
	appPtr = (CApaApplication**) sGlobalDataChunk.Base();
	*appPtr = app;
	DPRINT((HERE("CreateApplicationL - 4")));
}


void EikonExeL()
{
	DPRINT((HERE("EikonExeL - 1")));

	CreateApplicationL();

	DPRINT((HERE("EikonExeL - 2")));

	CApaCommandLine* apaCommandLine = CApaCommandLine::NewLC();
	apaCommandLine->SetLibraryNameL(APP_NAME);
	CleanupStack::Pop();
	EikDll::RunAppInsideThread(apaCommandLine);
	DPRINT((HERE("EikonExeL - 3")));
	sGlobalDataChunk.Close();
}


#if defined(__WINS__)
EXPORT_C TInt WinsMain()
#else
GLDEF_C TInt E32Main()
#endif
{
	__UHEAP_MARK;
	CTrapCleanup* cleanup = CTrapCleanup::New();
	if (cleanup)
	{
		DPRINT((HERE("E32Main")));

		TRAPD(error, EikonExeL());
	}
	delete cleanup;
	__UHEAP_MARKEND;
	return KErrNone;
}



#if defined(__WINS__)
TInt E32Dll(TDllReason)
{
	return 0;
}
#endif
