/*******************************************************************
 *
 *	File:		EChess.cpp
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2002, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#include <e32std.h>
#include <eikdll.h>
#include <eikappui.h>
#include <eikapp.h>
#include <eikdoc.h>
#include <apgtask.h>

#include "EGnuChessUids.h"

#ifdef __WINS__
#define APP_ON_C	_L("echess.dll")
#define APP_ON_D	_L("echess.dll")
#else
#define APP_ON_C	_L("c:\\system\\programs\\echess.exe")
#define APP_ON_D	_L("d:\\system\\programs\\echess.exe")
#endif

GLDEF_C TInt E32Dll(TDllReason)
{
	return KErrNone;
}




CApaApplication* GetApplication()
{
	CApaApplication*	app = NULL;
	RChunk				chunk;

	if (chunk.OpenGlobal(KGlobalEChessChunkName, EFalse) == KErrNone)
	{
		CApaApplication**	appPtr;
		appPtr = (CApaApplication**) chunk.Base();
		app = *appPtr;
		*appPtr = NULL;
		chunk.Close();
	}
	return app;
}


TBool ResumeEChess()
{
	RWsSession	wsSession;
	TInt	id = 0;
	if (wsSession.Connect() == KErrNone)
	{
		id = wsSession.FindWindowGroupIdentifier(id , _L("EGNUCHESS_FRONTEND"));
		if (id > 0)
		{
			TWsEvent	event;
			event.SetType(EEventUser+1);
			event.SetTimeNow();
			wsSession.SendEventToWindowGroup(id, event);
		}
		wsSession.Close();
	}
	return (id > 0);
}


void StartChessExeL()
{
	TRAPD(err, EikDll::StartExeL(APP_ON_C));
	if (err)
		EikDll::StartExeL(APP_ON_D);
}


EXPORT_C CApaApplication* NewApplication()
{
	CApaApplication*	app = NULL;

	if (!ResumeEChess())
	{
		app = GetApplication();
		if (app)
			return app;
		StartChessExeL();
	}

	User::After(2 * 1000 * 1000);
	User::Exit(0);
	return NULL;
}

