/*******************************************************************
 *
 *	File:		Debug.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2002, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/


#ifndef __DEBUG_H
#define __DEBUG_H


//#define WANT_DPRINT 1

#ifndef __cplusplus

#ifdef WANT_DPRINT
#define RDEBUG_PRINT(x) RDebugPrint x
#else
#define RDEBUG_PRINT(x) /**/
#endif

void RDebugPrint(const char* format, ...);

#else			/* __cplusplus */

extern "C"
{
	void RDebugPrint(const char* format, ...);
}


#include <e32svr.h>

/*
 * Some usefull macro's for debugging
 */

#define HEREL2(l)	L#l
#define HEREL1(l)	HEREL2(l)
#define TO_UNI1(s)	L##s
#define TO_UNI(s)	TO_UNI1(s)
#define HERE_STR(m) TO_UNI(__FILE__) L"(" HEREL1(__LINE__) L") : " L##m
#define HERE(m)	TPtrC((const TText *) HERE_STR(m))

#ifdef WANT_DPRINT
#define DPRINT(x) RDebug::Print x;
#else
#define DPRINT(x) /**/
#endif


#ifdef __WINS__
#define DEBUGGER() __asm int 3;
#else
#define DEBUGGER() /**/
#endif

#ifdef __WINS__
static	TBuf<256>	sTextBuffer;
static	TBuf<256>	sTextBuffer1;
__inline TDesC& DO_CONV_UNI(const char* s, TDes& aDes)
{
	TPtrC8	text8((TUint8*) (s));
	aDes.Copy(text8);
	return aDes;
}
__inline TDesC& CONV_UNI(const char* s)
{
	return DO_CONV_UNI(s, sTextBuffer);
}
__inline TDesC& CONV_UNI1(const char* s)
{
	return DO_CONV_UNI(s, sTextBuffer1);
}
__inline TDesC& CONV_TDES8_UNI_DES8(const TDesC8& aDes)
{
	sTextBuffer.Copy(aDes);
	return sTextBuffer;
}

#else
#define CONV_UNI(s) /**/
#define CONV_UNI1(s) /**/
#endif

#endif			/* __cplusplus */

#endif			/* __DEBUG_H */
